=== debian/changelog ===
wlcs (1.8.1-2) unstable; urgency=medium

  * debian/rules:
    + Disable WLCS_BUILD_UBSAN for i386 and s390x.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 30 Sep 2025 23:33:08 +0200

wlcs (1.8.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1114441).
  * debian/patches:
    + Drop 0001_remove-I-don-t-think-that-algorithm-does-what-you-th.patch.
      Part of this upstream release.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 13 Sep 2025 18:42:48 +0200
