=== debian/control ===
Source: wlcs
Section: devel
Priority: optional
Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
Uploaders:
 Debian UBports Team <team+ubports@tracker.debian.org>,
 Christopher James Halse Rogers <raof@ubuntu.com>,
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libffi-dev,
 libgtest-dev,
 libwayland-dev,
 pkgconf,
 google-mock
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/MirServer/wlcs
Vcs-Browser: https://salsa.debian.org/mir-server-team/wlcs
Vcs-Git: https://salsa.debian.org/mir-server-team/wlcs.git

Package: wlcs
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Wayland Conformance Suites
 wlcs aspires to be a protocol-conformance-verifying test suite usable by
 Wayland compositor implementations.
 .
 This package contains the headers necessary for a Wayland compositor to
 provide the integration module needed to run wlcs tests, and the test
 runner binary needed to run the tests against the compositor.
