=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s/.*\/v?([\d\.]+)\.tar\.gz/wlcs-$1.tar.gz/" \
https://github.com/MirServer/wlcs/tags .*/archive/refs/tags/v?([\d\.]+).tar.gz
